class SiteTimeline
  include Mongoid::Document
  include Mongoid::Timestamps

  field :test_site_creation_start, type: DateTime
  field :test_site_creation_end, type: DateTime
  field :test_site_creation_by
  field :test_site_creation_completed, type: DateTime

  field :template_design_images_start, type: DateTime
  field :template_design_images_end, type: DateTime
  field :template_design_images_by
  field :template_design_images_completed, type: DateTime

  field :template_html_css_start, type: DateTime
  field :template_html_css_end, type: DateTime
  field :template_html_css_by
  field :template_html_css_completed, type: DateTime

  field :customized_module_start, type: DateTime
  field :customized_module_end, type: DateTime
  field :customized_module_by
  field :customized_module_completed, type: DateTime

  field :data_migration_start, type: DateTime
  field :data_migration_end, type: DateTime
  field :data_migration_by
  field :data_migration_completed, type: DateTime

  field :site_structure_start, type: DateTime
  field :site_structure_end, type: DateTime
  field :site_structure_by
  field :site_structure_completed, type: DateTime

  field :site_migration_start, type: DateTime
  field :site_migration_end, type: DateTime
  field :site_migration_by
  field :site_migration_completed, type: DateTime

  field :psd_approval_completed, type: DateTime
  field :cutomer_approval_completed, type: DateTime
  field :module_approval_completed, type: DateTime

  belongs_to :site_request
end