$:.push File.expand_path("../lib", __FILE__)

# Maintain your gem's version:
require "client_management/version"

# Describe your gem and declare its dependencies:
Gem::Specification.new do |s|
  s.name        = "client_management"
  s.version     = ClientManagement::VERSION
  s.authors     = ["Harry Bomrah"]
  s.email       = ["harry@rulingcom.com"]
  s.homepage    = "http://www.rulingcom.com"
  s.summary     = "ClientManagement tool for store."
  s.description = "ClientManagement tool for store."
  s.license     = "MIT"
  s.add_dependency "net-ssh", ">= 4.0", "< 5.0"
  s.files = Dir["{app,config,db,lib}/**/*", "MIT-LICENSE", "Rakefile", "README.rdoc"]
  s.test_files = Dir["test/**/*"]
end
